<?php

	/*
		MarketPress Idealcheckoutmistercash Gateway Plugin
		Author: iDEAL Checkout - http://www.ideal-checkout.nl
	*/


	$sRootPath = dirname(dirname(dirname(dirname(dirname(dirname(__FILE__))))));
	require_once($sRootPath . '/idealcheckout/includes/library.php');


	class MP_Gateway_Idealcheckoutmistercash extends MP_Gateway_API
	{
		var $plugin_name = 'idealcheckoutmistercash';
		var $admin_name = '';
		var $public_name = '';
		var $force_ssl = false;
		var $ipn_url;
		var $skip_form = true;

		function on_creation() 
		{
			global $mp;

			$this->admin_name = 'iDEAL Checkout - MisterCash';
			$this->public_name = 'MisterCash';
		}

		function payment_form($cart, $shipping_info)
		{
			global $mp;

			if(isset($_GET['payment_method']) && ($_GET['payment_method'] == 'mistercash') && isset($_GET['payment_status']) && ($_GET['payment_status'] == 'cancelled'))
			{
				echo '<div class="mp_checkout_error">Uw betaling is geannuleerd.</div>';
			}
		}
	  
		function process_payment_form($cart, $shipping_info)
		{
			global $mp;

			return 'process_payment_form';
		}

		function process_payment($cart, $shipping_info)
		{
			global $mp, $wpdb;

			$aItems = array();
			$fOrderTotal = 0.00;

			foreach($cart as $product_id => $variations)
			{
				foreach($variations as $data)
				{
					$aItems[] = array(
						'product_id' => $product_id,
						'variant_code' => $data['SKU'],
						'variant_name' => $data['name'],
						'price' => $data['price'],
						'quantity' => $data['quantity'],
						'url' => $data['url'],
						'download' => $data['download']
					);

					$fOrderTotal += ($mp->before_tax_price($data['price'], $product_id) * $data['quantity']);
				}
			}

			if($aCoupon = $mp->coupon_value($mp->get_coupon_code(), $fOrderTotal))
			{
				$fOrderTotal = $aCoupon['new_total'];
			}
			
			// Calculate shipping
			if(($fShippingTotal = $mp->shipping_price()) !== false)
			{
				$fOrderTotal += $fShippingTotal;

				$aItems[] = array(
					'product_id' => false,
					'variant_code' => 'SHIPPING',
					'variant_name' => 'SHIPPING',
					'price' => $fShippingTotal,
					'quantity' => 1,
					'url' => false,
					'download' => false
				);
			}
			
			// Calculate VAT
			if(($fVatTotal = $mp->tax_price()) !== false)
			{
				$fOrderTotal += $fVatTotal;

				$aItems[] = array(
					'product_id' => false,
					'variant_code' => 'VAT',
					'variant_name' => 'VAT',
					'price' => $fVatTotal,
					'quantity' => 1,
					'url' => false,
					'download' => false
				);
			}



			$sOrderId = $mp->generate_order_id();

			$payment_info = array();
			$payment_info['gateway_public_name'] = $this->public_name;
			$payment_info['gateway_private_name'] = $this->admin_name;
			$payment_info['status'][time()] = 'OPEN';
			$payment_info['total'] = $fOrderTotal;
			$payment_info['currency'] = 'EUR';
			$payment_info['transaction_id'] = $sOrderId;  
			$payment_info['method'] = 'idealcheckoutmistercash';

			$order = $mp->create_order($_SESSION['mp_order'], $mp->get_cart_contents(), $_SESSION['mp_shipping_info'], $payment_info, false);






			$aDatabaseSettings = idealcheckout_getDatabaseSettings();


			$sStoreCode = idealcheckout_getStoreCode();
			$sGatewayCode = 'mistercash';
			$sLanguageCode = 'nl'; // nl, de, en
			$sCountryCode = '';
			$sCurrencyCode = 'EUR';

			// $sOrderId = $sOrderId;
			$sOrderCode = idealcheckout_getRandomCode(32);
			$aOrderParams = array();
			$sTransactionId = idealcheckout_getRandomCode(32);
			$sTransactionCode = idealcheckout_getRandomCode(32);
			$fTransactionAmount = round($fOrderTotal, 2);
			$sTransactionDescription = idealcheckout_getTranslation($sLanguageCode, 'idealcheckout', 'Webshop order #{0}', array($sOrderId));

			$sReturnUrl = mp_checkout_step_url('confirmation');
			$sReturnUrl .= ((strpos($sReturnUrl, '?')) ? '&' : '?') . 'order_id=' . $sOrderId . '&order_code=' . $sOrderCode;

			$sTransactionPaymentUrl = $sReturnUrl;
			$sTransactionSuccessUrl = $sReturnUrl;
			$sTransactionPendingUrl = $sReturnUrl;
			$sTransactionFailureUrl = $sReturnUrl;

			$aOrderParams['cart'] = $aItems;





			$aOrderParams['customer'] = array();

			// Shipment data
			list($sStreetName, $sStreetNumber) = idealcheckout_splitAddress($shipping_info['address1'] . ' ' . $shipping_info['address2']);
			list($sFirstName, $sLastName) = explode(' ', $shipping_info['name'], 2);

			$sCountryCode = $shipping_info['country'];
			$sCountryName = ((strcasecmp($sCountryCode, 'BE') === 0) ? 'Belgie' : 'Nederland');

			$aOrderParams['customer']['shipment_company'] = '';
			$aOrderParams['customer']['shipment_name'] = $shipping_info['name'];
			$aOrderParams['customer']['shipment_first_name'] = $sFirstName;
			$aOrderParams['customer']['shipment_last_name'] = $sLastName;
			$aOrderParams['customer']['shipment_gender'] = '';
			$aOrderParams['customer']['shipment_date_of_birth'] = '';
			$aOrderParams['customer']['shipment_phone'] = $shipping_info['phone'];
			$aOrderParams['customer']['shipment_email'] = $shipping_info['email'];
			$aOrderParams['customer']['shipment_address'] = $shipping_info['address1'] . (empty($shipping_info['address2']) ? '' : ', ' . $shipping_info['address2']);
			$aOrderParams['customer']['shipment_street_name'] = $sStreetName;
			$aOrderParams['customer']['shipment_street_number'] = $sStreetNumber;
			$aOrderParams['customer']['shipment_zipcode'] = $shipping_info['zip'];
			$aOrderParams['customer']['shipment_city'] = $shipping_info['city'];
			$aOrderParams['customer']['shipment_country_code'] = $sCountryCode;
			$aOrderParams['customer']['shipment_country_name'] = $sCountryName;


			// Payment data
			list($sStreetName, $sStreetNumber) = idealcheckout_splitAddress($shipping_info['address1'] . ' ' . $shipping_info['address2']);
			list($sFirstName, $sLastName) = explode(' ', $shipping_info['name'], 2);

			$sCountryCode = $shipping_info['country'];
			$sCountryName = ((strcasecmp($sCountryCode, 'BE') === 0) ? 'Belgie' : 'Nederland');

			$aOrderParams['customer']['payment_company'] = '';
			$aOrderParams['customer']['payment_name'] = $shipping_info['name'];
			$aOrderParams['customer']['payment_first_name'] = $sFirstName;
			$aOrderParams['customer']['payment_last_name'] = $sLastName;
			$aOrderParams['customer']['payment_gender'] = '';
			$aOrderParams['customer']['payment_date_of_birth'] = '';
			$aOrderParams['customer']['payment_phone'] = $shipping_info['phone'];
			$aOrderParams['customer']['payment_email'] = $shipping_info['email'];
			$aOrderParams['customer']['payment_address'] = $shipping_info['address1'] . (empty($shipping_info['address2']) ? '' : ', ' . $shipping_info['address2']);
			$aOrderParams['customer']['payment_street_name'] = $sStreetName;
			$aOrderParams['customer']['payment_street_number'] = $sStreetNumber;
			$aOrderParams['customer']['payment_zipcode'] = $shipping_info['zip'];
			$aOrderParams['customer']['payment_city'] = $shipping_info['city'];
			$aOrderParams['customer']['payment_country_code'] = $sCountryCode;
			$aOrderParams['customer']['payment_country_name'] = $sCountryName;


			$aOrderParams['products'] = array();
			$aOrderParams['products'][] = array('code' => $sOrderId, 'description' => $sTransactionDescription, 'quantity' => 1, 'price_incl' => $fTransactionAmount, 'price_excl' => $fTransactionAmount, 'vat' => 0);







			// Insert into #_transactions
			$sql = "INSERT INTO `" . $aDatabaseSettings['table'] . "` SET 
`id` = NULL, 
`order_id` = '" . idealcheckout_escapeSql($sOrderId) . "', 
`order_code` = '" . idealcheckout_escapeSql($sOrderCode) . "', 
`order_params` = '" . idealcheckout_escapeSql(serialize($aOrderParams)) . "', 
`store_code` = " . (empty($sStoreCode) ? "NULL" : "'" . idealcheckout_escapeSql($sStoreCode) . "'") . ", 
`gateway_code` = '" . idealcheckout_escapeSql($sGatewayCode) . "', 
`language_code` = " . (empty($sLanguageCode) ? "NULL" : "'" . idealcheckout_escapeSql($sLanguageCode) . "'") . ", 
`country_code` = " . (empty($sCountryCode) ? "NULL" : "'" . idealcheckout_escapeSql($sCountryCode) . "'") . ", 
`currency_code` = '" . idealcheckout_escapeSql($sCurrencyCode) . "', 
`transaction_id` = '" . idealcheckout_escapeSql($sTransactionId) . "', 
`transaction_code` = '" . idealcheckout_escapeSql($sTransactionCode) . "', 
`transaction_params` = NULL, 
`transaction_date` = '" . idealcheckout_escapeSql(time()) . "', 
`transaction_amount` = '" . idealcheckout_escapeSql($fTransactionAmount) . "', 
`transaction_description` = '" . idealcheckout_escapeSql($sTransactionDescription) . "', 
`transaction_status` = NULL, 
`transaction_url` = NULL, 
`transaction_payment_url` = '" . idealcheckout_escapeSql($sTransactionPaymentUrl) . "', 
`transaction_success_url` = '" . idealcheckout_escapeSql($sTransactionSuccessUrl) . "', 
`transaction_pending_url` = '" . idealcheckout_escapeSql($sTransactionPendingUrl) . "', 
`transaction_failure_url` = '" . idealcheckout_escapeSql($sTransactionFailureUrl) . "', 
`transaction_log` = NULL;";

			$wpdb->query($sql);


			$sRedirectUrl = idealcheckout_getRootUrl() . 'idealcheckout/setup.php?order_id=' . $sOrderId . '&order_code=' . $sOrderCode;

			wp_redirect($sRedirectUrl);
			exit;
		}

		function confirm_payment_form($cart, $shipping_info)
		{
			return '';
		}

		function order_confirmation($order)
		{
			global $mp, $wpdb;

			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			if($order && !empty($_GET['order_id']) && !empty($_GET['order_code']))
			{
				$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . idealcheckout_escapeSql($_GET['order_id']) . "') AND (`order_code` = '" . idealcheckout_escapeSql($_GET['order_code']) . "') LIMIT 1;";
				$aRecord = $wpdb->get_row($sql, ARRAY_A);

				if($aRecord && $aRecord['transaction_status'])
				{
					$aOrderParams = unserialize($aRecord['order_params']);

					if(isset($aOrderParams['last_status']) && (strcasecmp($aRecord['transaction_status'], $aOrderParams['last_status']) === 0))
					{
						if(in_array($aRecord['transaction_status'], array('SUCCESS')))
						{
							// return '<p>Uw betaling is ontvangen</p>';
						}
						elseif(in_array($aRecord['transaction_status'], array('PENDING')))
						{
							// return '<p>Uw betaling wordt verwerkt</p>';
						}
						else
						{
							// return '<p>Uw betaling is geannuleerd</p>';

							$this->_restoreCart($aRecord);

							$sRedirectUrl = mp_checkout_step_url('checkout');
							$sRedirectUrl .= ((strpos($sRedirectUrl, '?')) ? '&' : '?') . 'payment_method=mistercash&payment_status=cancelled';

							wp_redirect($sRedirectUrl);
							exit;
						}

						return;
					}
					else
					{
						$aOrderParams['last_status'] = $aRecord['transaction_status'];
						$sql = "UPDATE `" . $aDatabaseSettings['table'] . "` SET `order_params` = '" . idealcheckout_escapeSql(serialize($aOrderParams)) . "' WHERE (`id` = '" . $aRecord['id'] . "') LIMIT 1;";
						$wpdb->query($sql);
					}

/*
					$payment_info = $order->mp_payment_info;
					$payment_info['transaction_id'] = $aRecord['transaction_id'];
					$payment_info['status'][time()] = $aRecord['transaction_status'];
					$payment_info['method'] = 'idealcheckoutmistercash';

					update_post_meta($order->ID, 'mp_payment_info', $payment_info);
*/

					if(in_array($aRecord['transaction_status'], array('SUCCESS')))
					{
						$mp->update_order_payment_status($aRecord['order_id'], 'paid', true);
						// return '<p>Uw betaling is ontvangen.</p>';
					}
					elseif(in_array($aRecord['transaction_status'], array('PENDING')))
					{
						$mp->update_order_payment_status($aRecord['order_id'], 'paid', true);
						// return '<p>Uw betaling wordt verwerkt.</p>';
					}
					else
					{
						$mp->update_order_payment_status($aRecord['order_id'], 'paid', false);
						// return '<p>Uw betaling is geannuleerd.</p>';

						$this->_restoreCart($aRecord);

						$sRedirectUrl = mp_checkout_step_url('checkout');
						$sRedirectUrl .= ((strpos($sRedirectUrl, '?')) ? '&' : '?') . '&cancel=1';

						wp_redirect($sRedirectUrl);
						exit;
					}

					return;
				}
			}

			die('Invalid return');
		}

		function order_confirmation_email($msg, $order)
		{
			return $msg;
		}

		function order_confirmation_msg($content, $order)
		{
			global $mp, $wpdb;

			$aDatabaseSettings = idealcheckout_getDatabaseSettings();

			if($order && !empty($_GET['order_id']) && !empty($_GET['order_code']))
			{
				$sql = "SELECT * FROM `" . $aDatabaseSettings['table'] . "` WHERE (`order_id` = '" . idealcheckout_escapeSql($_GET['order_id']) . "') AND (`order_code` = '" . idealcheckout_escapeSql($_GET['order_code']) . "') LIMIT 1;";
				$aRecord = $wpdb->get_row($sql, ARRAY_A);

				if($aRecord && $aRecord['transaction_status'])
				{
					if(in_array($aRecord['transaction_status'], array('SUCCESS')))
					{
						$content = '<p>Uw betaling is ontvangen.</p>' . $content;
					}
					elseif(in_array($aRecord['transaction_status'], array('PENDING')))
					{
						$content = '<p>Uw betaling wordt verwerkt.</p>' . $content;
					}
					else
					{
						$content = '<p>Uw betaling is geannuleerd.</p>' . $content;
					}
				}
			}

			return $content;
		}
	
		function gateway_settings_box($settings)
		{
			global $mp;

			$aGatewaySettings = idealcheckout_getGatewaySettings(false, 'mistercash');

			$sHtml = '
	<div class="postbox">
    	<h3 class="handle"><span>iDEAL Checkout - MisterCash</span></h3>
		<div class="inside">

<p>Via deze plugin kunt u Mister Cash betalingen ontvangen in uw webshop via diverse Payment Service Providers.</p>
<p>Deze plugin is momenteel geconfigureerd om Mister Cash transacties te verwerken via <b>' . htmlspecialchars($aGatewaySettings['GATEWAY_NAME']) . '</b>.<br>Meer informatie over deze Payment Service Provider vind u op <a href="' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '" target="_blank">' . htmlspecialchars($aGatewaySettings['GATEWAY_WEBSITE']) . '</a></p>';

			if($aGatewaySettings['GATEWAY_VALIDATION'])
			{
				$sHtml .= '
<p>&nbsp;</p>
<h2>Transacties Controleren</h2>
<p>Controleer de status van alle openstaande transacties bij uw Payment Service Provider.</p>
<p><input type="button" value="Controleer openstaande transacties." onclick="javascript: window.open(\'' . idealcheckout_getRootUrl(1) . 'idealcheckout/validate.php?gateway=mistercash\', \'popup\', \'directories=no,height=550,location=no,menubar=no,resizable=yes,scrollbars=yes,status=no,toolbar=no,width=750\');"></p>';
			}

			$sHtml .= '
<p>&nbsp;</p>
<h2>Over deze plugin</h2>
<p>Deze Mister Cash plugin is ontwikkeld door <a href="https://www.ideal-checkout.nl" target="_blank">iDEAL Checkout</a> en is GRATIS te downloaden via <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a>.<br><br>- Voor vragen en support, kijk op <a href="http://www.ideal-checkout.nl" target="_blank">http://www.ideal-checkout.nl</a> of neem contact op met <a href="mailto:info@ideal-checkout.nl">info@ideal-checkout.nl</a>.<br>- Feedback en donaties worden zeer op prijs gesteld.<br>- Het gebruik van onze plugins/scripts is geheel op eigen risico.</p>

		</div>
	</div>';

			echo $sHtml;
		}
  
		function process_gateway_settings($settings)
		{
			return $settings;
		}

		function process_ipn_return()
		{
		}


		function _restoreCart($aRecord)
		{
			global $mp, $blog_id;

			$current_blog_id = (is_multisite()) ? $blog_id : 1;

			if(!empty($aRecord['order_params']))
			{
				$aOrderParams = unserialize($aRecord['order_params']);

				if(is_array($aOrderParams['cart']) && sizeof($aOrderParams['cart']))
				{
					$cart = array();

					foreach($aOrderParams['cart'] as $a)
					{
						if($a['product_id'])
						{
							// $cart[$a['product_id']][$a['variant_code']] = $a['quantity'];
							$cart[$a['product_id']][] = $a['quantity'];
						}
					}

					$mp->set_cart_cookie($cart);
				}
			}
		}
	}

	mp_register_gateway_plugin('MP_Gateway_Idealcheckoutmistercash', 'idealcheckoutmistercash', 'iDEAL Checkout - MisterCash');

?>